## anbox 0.0~git20191115

=== CMakeLists.txt ===
project(anbox C CXX)
cmake_minimum_required(VERSION 2.8.2)

include(CTest)
include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wno-variadic-macros -Wextra -fPIC")

# By default, all symbols are visible in the library. We strip out things we don't
# want at link time, by running a version script (see unity-scopes.map and the
# setting of LINK_FLAGS below).
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=default")

set(C_AND_CXX_WARNINGS "-pedantic -Wall -Wextra")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wold-style-cast")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_AND_CXX_WARNINGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_WARNINGS}")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 ${C_AND_CXX_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_WARNINGS}")

# -fno-permissive causes warnings with clang, so we only enable it for gcc
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
  option(Werror "Treat warnings as errors" ON)
else()
  option(Werror "Treat warnings as errors" OFF)
endif()

if (${Werror})
    message(STATUS "Treat warnings as errors")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=deprecated-declarations")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
  endif()
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Boost COMPONENTS filesystem log serialization system thread program_options)
find_package(PkgConfig)
find_package(Threads)
find_package(EGL REQUIRED)
find_package(GLESv2 REQUIRED)
find_package(Protobuf REQUIRED)

pkg_check_modules(SDL2 sdl2 REQUIRED)
pkg_check_modules(SDL2_IMAGE SDL2_image REQUIRED)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(LXC lxc REQUIRED)
pkg_check_modules(PROPERTIES_CPP properties-cpp REQUIRED)
pkg_check_modules(LIBSYSTEMD libsystemd REQUIRED)

message(STATUS "LXC version: ${LXC_VERSION}")
if (${LXC_VERSION} VERSION_LESS 3.0)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_LXC2_SUPPORT")
  message(STATUS "Building with LXC 2.x compatibility support")
endif()

option(ENABLE_X11 "Enable X11 support" ON)
if (ENABLE_X11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DX11_SUPPORT")
endif()

option(ENABLE_WAYLAND "Enable wayland support" ON)
if (ENABLE_WAYLAND)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWAYLAND_SUPPORT")
endif()

option(ENABLE_MIR "Enable mir support" OFF)
if (ENABLE_MIR)
  pkg_check_modules(MIRCLIENT mirclient REQUIRED)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMIR_SUPPORT")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DEGL_NO_X11")

if((Protobuf_VERSION VERSION_GREATER "3.7") OR (Protobuf_VERSION VERSION_EQUAL "3.7"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DUSE_PROTOBUF_CALLBACK_HEADER")
endif()

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

find_package(GMock)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fPIC")


if (NOT ANBOX_VERSION)
    exec_program("git" ${CMAKE_SOURCE_DIR} ARGS "rev-parse --short HEAD" OUTPUT_VARIABLE GIT_COMMIT_HASH)
    set(ANBOX_VERSION "local-${GIT_COMMIT_HASH}")
endif()
if (ANBOX_VERSION_SUFFIX)
    set(ANBOX_VERSION "${ANBOX_VERSION}-${ANBOX_VERSION_SUFFIX}")
endif()
set(ANBOX_RESOURCE_DIR "${CMAKE_INSTALL_DATADIR}/anbox")
set(ANBOX_RESOURCE_DIR_FULL "${CMAKE_INSTALL_FULL_DATADIR}/anbox")
set(ANBOX_STATEDIR_FULL "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/anbox")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/anbox/build/config.h.in
               ${CMAKE_CURRENT_SOURCE_DIR}/src/anbox/build/config.h)

add_subdirectory(external)
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(android)

if (NOT "${HOST_CMAKE_C_COMPILER}" STREQUAL "")
  message(STATUS "Host C compiler: ${HOST_CMAKE_C_COMPILER}")
  message(STATUS "Host C compiler: ${HOST_CMAKE_CXX_COMPILER}")
endif()

option(SNAP_CONFINEMENT "Enable snap confinement support" OFF)
if (SNAP_CONFINEMENT)
  message(STATUS "Building with support for snap confinement")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_SNAP_CONFINEMENT")
endif()

install(FILES data/ui/loading-screen.png DESTINATION ${ANBOX_RESOURCE_DIR}/ui)

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== external/CMakeLists.txt ===
add_subdirectory(process-cpp-minimal)
add_subdirectory(android-emugl)
add_subdirectory(xdg)
add_subdirectory(backward-cpp)
add_subdirectory(cpu_features)

=== src/CMakeLists.txt ===
include_directories(
  ${Boost_INCLUDE_DIRS}
  ${MIRCLIENT_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
  ${SDL2_INCLUDE_DIRS}
  ${SDL2_IMAGE_INCLUDE_DIRS}
  ${PROPERTIES_CPP_INCLUDE_DIRS}
  ${LXC_INCLUDE_DIRS}
  ${MIRCLIENT_INCLUDE_DIRS}
  ${LIBSYSTEMD_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/external
  ${CMAKE_SOURCE_DIR}/external/process-cpp-minimal/include
  ${CMAKE_SOURCE_DIR}/external/android-emugl/shared
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/include
  ${CMAKE_SOURCE_DIR}/external/android-emugl/shared/OpenglCodecCommon
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include/libOpenglRender
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/GLESv1_dec
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/GLESv1_dec
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/GLESv2_dec
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/GLESv2_dec
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/renderControl_dec
  ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/renderControl_dec
  ${CMAKE_SOURCE_DIR}/external/glm
  ${CMAKE_SOURCE_DIR}/external/cpu_features/include
)

protobuf_generate_cpp(
    GENERATED_PROTOBUF_RPC_SRCS GENERATED_PROTOBUF_RPC_HDRS
    anbox/protobuf/anbox_rpc.proto)

protobuf_generate_cpp(
    GENERATED_PROTOBUF_BRIDGE_SRCS GENERATED_PROTOBUF_BRIDGE_HDRS
    anbox/protobuf/anbox_bridge.proto)

protobuf_generate_cpp(
    GENERATED_PROTOBUF_CONTAINER_SRCS GENERATED_PROTOBUF_CONTAINER_HDRS
    anbox/protobuf/anbox_container.proto)


add_library(anbox-protobuf
    STATIC
    ${GENERATED_PROTOBUF_BRIDGE_SRCS}
    ${GENERATED_PROTOBUF_BRIDGE_HDRS}
    ${GENERATED_PROTOBUF_RPC_SRCS}
    ${GENERATED_PROTOBUF_RPC_HDRS}
    ${GENERATED_PROTOBUF_CONTAINER_SRCS}
    ${GENERATED_PROTOBUF_CONTAINER_HDRS}
    anbox/protobuf/anbox_rpc.proto
    anbox/protobuf/anbox_bridge.proto
    anbox/protobuf/anbox_container.proto
    anbox/protobuf/google_protobuf_guard.cpp)
target_link_libraries(anbox-protobuf
    ${PROTOBUF_LITE_LIBRARIES})

set(SOURCES
    anbox/android/intent.cpp
    anbox/android/intent.h
    anbox/android/ip_config_builder.cpp
    anbox/android/ip_config_builder.h

    anbox/application/database.cpp
    anbox/application/database.h
    anbox/application/launcher_storage.cpp
    anbox/application/launcher_storage.h
    anbox/application/manager.h

    anbox/audio/client_info.h
    anbox/audio/server.cpp
    anbox/audio/server.h
    anbox/audio/sink.h
    anbox/audio/source.h

    anbox/bridge/android_api_stub.cpp
    anbox/bridge/android_api_stub.h
    anbox/bridge/platform_api_skeleton.cpp
    anbox/bridge/platform_api_skeleton.h
    anbox/bridge/platform_message_processor.cpp
    anbox/bridge/platform_message_processor.h

    anbox/build/config.h
    anbox/build/config.h.in

    anbox/cmds/container_manager.cpp
    anbox/cmds/container_manager.h
    anbox/cmds/launch.cpp
    anbox/cmds/launch.h
    anbox/cmds/session_manager.cpp
    anbox/cmds/session_manager.h
    anbox/cmds/system_info.cpp
    anbox/cmds/system_info.h
    anbox/cmds/version.cpp
    anbox/cmds/version.h
    anbox/cmds/wait_ready.cpp
    anbox/cmds/wait_ready.h
    anbox/cmds/check_features.cpp
    anbox/cmds/check_features.h

    anbox/common/binary_writer.cpp
    anbox/common/binary_writer.h
    anbox/common/dispatcher.cpp
    anbox/common/dispatcher.h
    anbox/common/fd.cpp
    anbox/common/fd.h
    anbox/common/fd_sets.h
    anbox/common/loop_device_allocator.cpp
    anbox/common/loop_device_allocator.h
    anbox/common/loop_device.cpp
    anbox/common/loop_device.h
    anbox/common/message_channel.cpp
    anbox/common/message_channel.h
    anbox/common/mount_entry.cpp
    anbox/common/mount_entry.h
    anbox/common/scope_ptr.h
    anbox/common/small_vector.h
    anbox/common/type_traits.h
    anbox/common/variable_length_array.h
    anbox/common/wait_handle.cpp
    anbox/common/wait_handle.h

    anbox/container/client.cpp
    anbox/container/client.h
    anbox/container/configuration.h
    anbox/container/container.cpp
    anbox/container/container.h
    anbox/container/lxc_container.cpp
    anbox/container/lxc_container.h
    anbox/container/management_api_message_processor.cpp
    anbox/container/management_api_message_processor.h
    anbox/container/management_api_skeleton.cpp
    anbox/container/management_api_skeleton.h
    anbox/container/management_api_stub.cpp
    anbox/container/management_api_stub.h
    anbox/container/service.cpp
    anbox/container/service.h

    anbox/dbus/bus.cpp
    anbox/dbus/bus.h
    anbox/dbus/codecs.h
    anbox/dbus/interface.h
    anbox/dbus/sd_bus_helpers.c
    anbox/dbus/sd_bus_helpers.h
    anbox/dbus/sd_bus_helpers.hpp
    anbox/dbus/skeleton/application_manager.cpp
    anbox/dbus/skeleton/application_manager.h
    anbox/dbus/skeleton/service.cpp
    anbox/dbus/skeleton/service.h
    anbox/dbus/stub/application_manager.cpp
    anbox/dbus/stub/application_manager.h

    anbox/graphics/buffered_io_stream.cpp
    anbox/graphics/buffered_io_stream.h
    anbox/graphics/buffer_queue.cpp
    anbox/graphics/buffer_queue.h
    anbox/graphics/density.cpp
    anbox/graphics/density.h
    anbox/graphics/gl_extensions.h
    anbox/graphics/gl_renderer_server.cpp
    anbox/graphics/gl_renderer_server.h
    anbox/graphics/layer_composer.cpp
    anbox/graphics/layer_composer.h
    anbox/graphics/multi_window_composer_strategy.cpp
    anbox/graphics/multi_window_composer_strategy.h
    anbox/graphics/opengles_message_processor.cpp
    anbox/graphics/opengles_message_processor.h
    anbox/graphics/primitives.h
    anbox/graphics/program_family.cpp
    anbox/graphics/program_family.h
    anbox/graphics/rect.cpp
    anbox/graphics/rect.h
    anbox/graphics/renderer.h
    anbox/graphics/single_window_composer_strategy.cpp
    anbox/graphics/single_window_composer_strategy.h

    anbox/graphics/emugl/ColorBuffer.cpp
    anbox/graphics/emugl/ColorBuffer.h
    anbox/graphics/emugl/DispatchTables.h
    anbox/graphics/emugl/DisplayManager.cpp
    anbox/graphics/emugl/DisplayManager.h
    anbox/graphics/emugl/ReadBuffer.cpp
    anbox/graphics/emugl/ReadBuffer.h
    anbox/graphics/emugl/Renderable.cpp
    anbox/graphics/emugl/Renderable.h
    anbox/graphics/emugl/RenderApi.cpp
    anbox/graphics/emugl/RenderApi.h
    anbox/graphics/emugl/RenderContext.cpp
    anbox/graphics/emugl/RenderContext.h
    anbox/graphics/emugl/RenderControl.cpp
    anbox/graphics/emugl/RenderControl.h
    anbox/graphics/emugl/RendererConfig.cpp
    anbox/graphics/emugl/RendererConfig.h
    anbox/graphics/emugl/Renderer.cpp
    anbox/graphics/emugl/Renderer.h
    anbox/graphics/emugl/RenderThread.cpp
    anbox/graphics/emugl/RenderThread.h
    anbox/graphics/emugl/RenderThreadInfo.cpp
    anbox/graphics/emugl/RenderThreadInfo.h
    anbox/graphics/emugl/TextureDraw.cpp
    anbox/graphics/emugl/TextureDraw.h
    anbox/graphics/emugl/TextureResize.cpp
    anbox/graphics/emugl/TextureResize.h
    anbox/graphics/emugl/TimeUtils.cpp
    anbox/graphics/emugl/TimeUtils.h
    anbox/graphics/emugl/WindowSurface.cpp
    anbox/graphics/emugl/WindowSurface.h

    anbox/input/device.cpp
    anbox/input/device.h
    anbox/input/manager.cpp
    anbox/input/manager.h

    anbox/network/base_socket_messenger.cpp
    anbox/network/base_socket_messenger.h
    anbox/network/connection_context.cpp
    anbox/network/connection_context.h
    anbox/network/connection_creator.cpp
    anbox/network/connection_creator.h
    anbox/network/connections.h
    anbox/network/connector.h
    anbox/network/credentials.cpp
    anbox/network/credentials.h
    anbox/network/delegate_connection_creator.h
    anbox/network/delegate_message_processor.cpp
    anbox/network/delegate_message_processor.h
    anbox/network/fd_socket_transmission.cpp
    anbox/network/fd_socket_transmission.h
    anbox/network/local_socket_messenger.cpp
    anbox/network/local_socket_messenger.h
    anbox/network/message_processor.h
    anbox/network/message_receiver.h
    anbox/network/message_sender.h
    anbox/network/published_socket_connector.cpp
    anbox/network/published_socket_connector.h
    anbox/network/socket_connection.cpp
    anbox/network/socket_connection.h
    anbox/network/socket_helper.cpp
    anbox/network/socket_helper.h
    anbox/network/socket_messenger.cpp
    anbox/network/socket_messenger.h
    anbox/network/tcp_socket_connector.cpp
    anbox/network/tcp_socket_connector.h
    anbox/network/tcp_socket_messenger.cpp
    anbox/network/tcp_socket_messenger.h

    anbox/platform/base_platform.cpp
    anbox/platform/base_platform.h
    anbox/platform/null/platform.cpp
    anbox/platform/null/platform.h
    anbox/platform/sdl/audio_sink.cpp
    anbox/platform/sdl/audio_sink.h
    anbox/platform/sdl/keycode_converter.cpp
    anbox/platform/sdl/keycode_converter.h
    anbox/platform/sdl/platform.cpp
    anbox/platform/sdl/platform.h
    anbox/platform/sdl/sdl_wrapper.h
    anbox/platform/sdl/window.cpp
    anbox/platform/sdl/window.h

    anbox/protobuf/anbox_bridge.proto
    anbox/protobuf/anbox_container.proto
    anbox/protobuf/anbox_rpc.proto
    anbox/protobuf/google_protobuf_guard.cpp

    anbox/qemu/adb_message_processor.cpp
    anbox/qemu/adb_message_processor.h
    anbox/qemu/at_parser.cpp
    anbox/qemu/at_parser.h
    anbox/qemu/bootanimation_message_processor.cpp
    anbox/qemu/bootanimation_message_processor.h
    anbox/qemu/boot_properties_message_processor.cpp
    anbox/qemu/boot_properties_message_processor.h
    anbox/qemu/camera_message_processor.cpp
    anbox/qemu/camera_message_processor.h
    anbox/qemu/fingerprint_message_processor.cpp
    anbox/qemu/fingerprint_message_processor.h
    anbox/qemu/gsm_message_processor.cpp
    anbox/qemu/gsm_message_processor.h
    anbox/qemu/hwcontrol_message_processor.cpp
    anbox/qemu/hwcontrol_message_processor.h
    anbox/qemu/null_message_processor.cpp
    anbox/qemu/null_message_processor.h
    anbox/qemu/pipe_connection_creator.cpp
    anbox/qemu/pipe_connection_creator.h
    anbox/qemu/qemud_message_processor.cpp
    anbox/qemu/qemud_message_processor.h
    anbox/qemu/sensors_message_processor.cpp
    anbox/qemu/sensors_message_processor.h

    anbox/rpc/channel.cpp
    anbox/rpc/channel.h
    anbox/rpc/connection_creator.cpp
    anbox/rpc/connection_creator.h
    anbox/rpc/constants.h
    anbox/rpc/make_protobuf_object.h
    anbox/rpc/message_processor.cpp
    anbox/rpc/message_processor.h
    anbox/rpc/pending_call_cache.cpp
    anbox/rpc/pending_call_cache.h
    anbox/rpc/template_message_processor.h

    anbox/testing/gtest_utils.h

    anbox/ui/splash_screen.cpp
    anbox/ui/splash_screen.h

    anbox/utils/environment_file.cpp
    anbox/utils/environment_file.h

    anbox/wm/display.cpp
    anbox/wm/display.h
    anbox/wm/manager.cpp
    anbox/wm/manager.h
    anbox/wm/multi_window_manager.cpp
    anbox/wm/multi_window_manager.h
    anbox/wm/single_window_manager.cpp
    anbox/wm/single_window_manager.h
    anbox/wm/stack.cpp
    anbox/wm/stack.h
    anbox/wm/task.cpp
    anbox/wm/task.h
    anbox/wm/window.cpp
    anbox/wm/window.h
    anbox/wm/window_state.cpp
    anbox/wm/window_state.h

    anbox/cli.cpp
    anbox/cli.h
    anbox/daemon.cpp
    anbox/daemon.h
    anbox/defer_action.h
    anbox/do_not_copy_or_move.h
    anbox/logger.cpp
    anbox/logger.h
    anbox/not_reachable.cpp
    anbox/not_reachable.h
    anbox/optional.h
    anbox/utils.cpp
    anbox/utils.h
    anbox/runtime.cpp
    anbox/runtime.h
    anbox/system_configuration.cpp
    anbox/system_configuration.h)

add_library(anbox-core STATIC ${SOURCES})
target_link_libraries(anbox-core
  ${Boost_LDFLAGS}
  ${Boost_LIBRARIES}
  ${SDL2_LDFLAGS}
  ${SDL2_LIBRARIES}
  ${SDL2_IMAGE_LDFLAGS}
  ${SDL2_IMAGE_LIBRARIES}
  ${LXC_LDFLAGS}
  ${LXC_LIBRARIES}
  ${MIRCLIENT_LDFLAGS}
  ${MIRCLIENT_LIBRARIES}

=== external/android-emugl/CMakeLists.txt ===
# Don't treat any warnings as error as we take the source directly from
# upstream and just compile it.
set(CMAKE_C_FLAGS "-Wall")
set(CMAKE_CXX_FLAGS "-std=c++11 -Wall")

# Ensure -fPIC
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

include_directories(
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/external/android-emugl/shared
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include
    ${CMAKE_BINARY_DIR}/external/android-emugl/host/include
    ${CMAKE_SOURCE_DIR}/external/android-emugl/shared/OpenglCodecCommon
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include/libOpenglRender
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/GLESv1_dec
    ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/GLESv1_dec
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/GLESv2_dec
    ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/GLESv2_dec
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/renderControl_dec
    ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/renderControl_dec
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/Translator/
    ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/Translator/include
    ${MIRCLIENT_INCLUDE_DIRS})

add_subdirectory(host)
add_subdirectory(shared)

=== external/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)
project(backward CXX)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

# Anbox: allow old-style cast, unknown pragmas
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=old-style-cast -Wno-error=unknown-pragmas -Wno-error=switch-default")

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

###############################################################################
# TESTS
###############################################################################

if(BACKWARD_TESTS)
	enable_testing()

	add_library(test_main SHARED test/_test_main.cpp)

	macro(backward_add_test src)
		get_filename_component(name ${src} NAME_WE)
		set(test_name "test_${name}")

		add_executable(${test_name} ${src} ${ARGN})

		target_link_libraries(${test_name} PRIVATE Backward::Backward test_main)

		add_test(NAME ${name} COMMAND ${test_name})
	endmacro()

	# Tests without backward.cpp
	set(TESTS
		test
		stacktrace
		rectrace
		select_signals
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp)
	endforeach()

	# Tests with backward.cpp
	set(TESTS
		suicide
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp ${BACKWARD_ENABLE})
	endforeach()
endif()

install(
    FILES "backward.hpp"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)
install(
    FILES "BackwardConfig.cmake"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/backward
)

=== tests/anbox/CMakeLists.txt ===
add_subdirectory(android)
add_subdirectory(application)
add_subdirectory(support)
add_subdirectory(common)
add_subdirectory(graphics)

=== external/android-emugl/host/CMakeLists.txt ===
add_subdirectory(tools)
add_subdirectory(libs)

=== external/android-emugl/shared/CMakeLists.txt ===
add_subdirectory(emugl)
add_subdirectory(OpenglCodecCommon)

=== external/cpu_features/test/CMakeLists.txt ===
#
# libraries for tests
#

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF) # prefer use of -std11 instead of -gnustd11

include_directories(../include)
add_definitions(-DCPU_FEATURES_TEST)

##------------------------------------------------------------------------------
add_library(string_view ../src/string_view.c)
##------------------------------------------------------------------------------
add_library(filesystem_for_testing filesystem_for_testing.cc)
##------------------------------------------------------------------------------
add_library(hwcaps_for_testing hwcaps_for_testing.cc)
target_link_libraries(hwcaps_for_testing filesystem_for_testing)
##------------------------------------------------------------------------------
add_library(stack_line_reader ../src/stack_line_reader.c)
target_compile_definitions(stack_line_reader PUBLIC STACK_LINE_READER_BUFFER_SIZE=1024)
target_link_libraries(stack_line_reader string_view)
##------------------------------------------------------------------------------
add_library(stack_line_reader_for_test ../src/stack_line_reader.c)
target_compile_definitions(stack_line_reader_for_test PUBLIC STACK_LINE_READER_BUFFER_SIZE=16)
target_link_libraries(stack_line_reader_for_test string_view filesystem_for_testing)
##------------------------------------------------------------------------------
add_library(all_libraries ../src/stack_line_reader.c ../src/linux_features_aggregator.c)
target_link_libraries(all_libraries hwcaps_for_testing stack_line_reader string_view)

#
# tests
#
link_libraries(gtest gmock_main)

## bit_utils_test
add_executable(bit_utils_test bit_utils_test.cc)
target_link_libraries(bit_utils_test)
add_test(NAME bit_utils_test COMMAND bit_utils_test)
##------------------------------------------------------------------------------
## string_view_test
add_executable(string_view_test string_view_test.cc ../src/string_view.c)
target_link_libraries(string_view_test string_view)
add_test(NAME string_view_test COMMAND string_view_test)
##------------------------------------------------------------------------------
## stack_line_reader_test
add_executable(stack_line_reader_test stack_line_reader_test.cc)
target_link_libraries(stack_line_reader_test stack_line_reader_for_test)
add_test(NAME stack_line_reader_test COMMAND stack_line_reader_test)
##------------------------------------------------------------------------------
## linux_features_aggregator_test
add_executable(linux_features_aggregator_test linux_features_aggregator_test.cc)
target_link_libraries(linux_features_aggregator_test all_libraries)
add_test(NAME linux_features_aggregator_test COMMAND linux_features_aggregator_test)
##------------------------------------------------------------------------------
## cpuinfo_x86_test
add_executable(cpuinfo_x86_test cpuinfo_x86_test.cc ../src/cpuinfo_x86.c)
target_link_libraries(cpuinfo_x86_test all_libraries)
add_test(NAME cpuinfo_x86_test COMMAND cpuinfo_x86_test)
##------------------------------------------------------------------------------
## cpuinfo_arm_test
add_executable(cpuinfo_arm_test cpuinfo_arm_test.cc ../src/cpuinfo_arm.c)
target_link_libraries(cpuinfo_arm_test all_libraries)
add_test(NAME cpuinfo_arm_test COMMAND cpuinfo_arm_test)
##------------------------------------------------------------------------------
## cpuinfo_aarch64_test
add_executable(cpuinfo_aarch64_test cpuinfo_aarch64_test.cc ../src/cpuinfo_aarch64.c)
target_link_libraries(cpuinfo_aarch64_test all_libraries)
add_test(NAME cpuinfo_aarch64_test COMMAND cpuinfo_aarch64_test)
##------------------------------------------------------------------------------
## cpuinfo_mips_test
add_executable(cpuinfo_mips_test cpuinfo_mips_test.cc  ../src/cpuinfo_mips.c)
target_link_libraries(cpuinfo_mips_test all_libraries)
add_test(NAME cpuinfo_mips_test COMMAND cpuinfo_mips_test)
##------------------------------------------------------------------------------
## cpuinfo_ppc_test
add_executable(cpuinfo_ppc_test cpuinfo_ppc_test.cc  ../src/cpuinfo_ppc.c)
target_link_libraries(cpuinfo_ppc_test all_libraries)
add_test(NAME cpuinfo_ppc_test COMMAND cpuinfo_ppc_test)

=== tests/anbox/application/CMakeLists.txt ===
ANBOX_ADD_TEST(restricted_manager_tests restricted_manager_tests.cpp)

=== tests/anbox/common/CMakeLists.txt ===
ANBOX_ADD_TEST(message_channel_tests message_channel_tests.cpp)
ANBOX_ADD_TEST(small_vector_tests small_vector_tests.cpp)
ANBOX_ADD_TEST(type_traits_tests type_traits_tests.cpp)
ANBOX_ADD_TEST(scope_ptr_tests scope_ptr_tests.cpp)
ANBOX_ADD_TEST(binary_writer_tests binary_writer_tests.cpp)

=== external/android-emugl/host/libs/CMakeLists.txt ===
FUNCTION(PREPEND var prefix)
   SET(listVar "")
   FOREACH(f ${ARGN})
      LIST(APPEND listVar "${prefix}/${f}")
   ENDFOREACH(f)
   SET(${var} "${listVar}" PARENT_SCOPE)
ENDFUNCTION(PREPEND)

PREPEND(GLHEADERS_SOURCES libOpenGLESDispatch/
    render_egl_extensions.entries
    render_egl.entries
    gles_common.entries
    gles_extensions.entries
    gles1_only.entries
    gles1_extensions.entries
    gles2_only.entries
    gles2_extensions.entries
    gles3_only.entries)

PREPEND(GLHEADERS_GENERATED_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/../include/OpenGLESDispatch/
    gles1_extensions_functions.h
    gles1_only_functions.h
    gles2_extensions_functions.h
    gles2_only_functions.h
    gles3_only_functions.h
    gles_common_functions.h
    gles_extensions_functions.h
    RenderEGL_extensions_functions.h
    RenderEGL_functions.h)

add_custom_command(
    OUTPUT ${GLHEADERS_GENERATED_SOURCES}
    COMMAND ${CMAKE_SOURCE_DIR}/scripts/gen-emugl-headers.sh ${CMAKE_BINARY_DIR}
    DEPENDS ${GLHEADERS_SOURCES}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

include(GLESv1_dec/CMakeLists.txt)
include(GLESv2_dec/CMakeLists.txt)
include(libOpenGLESDispatch/CMakeLists.txt)
include(renderControl_dec/CMakeLists.txt)

=== debian/changelog ===
anbox (0.0~git20191115-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 19:51:23 +0000

anbox (0.0~git20191115-1) unstable; urgency=medium

  * New upstream snapshot.
    + Fix FTBFS with protobuf 3.10.1. (Closes: #944996)
    + Set default command argv to help. (Closes: #930200)

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 18 Nov 2019 23:13:33 +0800

anbox (0.0~git20191022-1) unstable; urgency=medium

  * New upstream snapshot.
  * Update debhelper compat to 12
  * Update Standards-Version to 4.4.1 (no changes)
  * Drop 0006-unsafe-workaround-for-issue-1057.patch
  * Add patch to fix FTBFS issue for gmock (Closes: #943647)
  * Update anbox manpage (Closes: #931070)
  * Update README.Debian, better phrase (Closes: #930202)

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 27 Oct 2019 23:28:12 +0800

=== debian/control ===
Source: anbox
Section: contrib/utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Shengjing Zhu <zhsj@debian.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-log-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libcap-dev,
 libegl1-mesa-dev,
 libgles2-mesa-dev,
 libgmock-dev,
 libproperties-cpp-dev,
 libprotobuf-dev,
 libsdl2-dev,
 libsdl2-image-dev,
 libsystemd-dev,
 lxc-dev,
 protobuf-compiler,
 python3,
Standards-Version: 4.4.1
Homepage: https://anbox.io
Vcs-Git: https://salsa.debian.org/zhsj/anbox.git
Vcs-Browser: https://salsa.debian.org/zhsj/anbox

Package: anbox
Architecture: amd64 arm64 armhf
Built-Using:
 ${misc:Built-Using},
Depends:
 iptables,
 libegl1,
 libgles2,
 ${misc:Depends},
 ${misc:LxcDepends},
 ${shlibs:Depends},
Recommends:
 dbus-user-session,
Description: Android in a box
 Anbox is a container-based approach to boot a full Android system on a
 regular GNU/Linux system.
 .
 In other words: Anbox will let you run Android on your Linux system
 without the slowness of virtualization.
 .
 Anbox uses Linux namespaces (user, pid, uts, net, mount, ipc) to run a
 full Android system in a container and provide Android applications on any
 GNU/Linux-based platform.
 .
 The Android inside the container has no direct access to any hardware. All
 hardware access is going through the anbox daemon on the host. It reuses
 what Android implemented within the QEMU-based emulator for OpenGL ES
 accelerated rendering. The Android system inside the container uses
 different pipes to communicate with the host system and sends all hardware
 access commands through these.
 .
 This package needs Android kernel modules and rootfs image, see
 /usr/share/doc/anbox/README.Debian for information.

=== debian/tests/control ===
Test-Command: anbox system-info

## anbox 0.0~git20200526

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,6 +69,7 @@
 pkg_check_modules(LXC lxc REQUIRED)
 pkg_check_modules(PROPERTIES_CPP properties-cpp REQUIRED)
 pkg_check_modules(LIBSYSTEMD libsystemd REQUIRED)
+pkg_check_modules(LIBCAP libcap REQUIRED)
 
 message(STATUS "LXC version: ${LXC_VERSION}")
 if (${LXC_VERSION} VERSION_LESS 3.0)
@@ -90,6 +91,10 @@
 if (ENABLE_MIR)
   pkg_check_modules(MIRCLIENT mirclient REQUIRED)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMIR_SUPPORT")
+endif()
+
+if (NOT BINDERFS_PATH)
+  set(BINDERFS_PATH "/dev/binderfs")
 endif()
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DEGL_NO_X11")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,10 @@
   ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/GLESv2_dec
   ${CMAKE_SOURCE_DIR}/external/android-emugl/host/libs/renderControl_dec
   ${CMAKE_BINARY_DIR}/external/android-emugl/host/libs/renderControl_dec
-  ${CMAKE_SOURCE_DIR}/external/glm
   ${CMAKE_SOURCE_DIR}/external/cpu_features/include
 )
+
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBINDERFS_PATH=\"\\\"${BINDERFS_PATH}\\\"\"")
 
 protobuf_generate_cpp(
     GENERATED_PROTOBUF_RPC_SRCS GENERATED_PROTOBUF_RPC_HDRS
@@ -121,6 +122,11 @@
     anbox/common/variable_length_array.h
     anbox/common/wait_handle.cpp
     anbox/common/wait_handle.h
+    anbox/common/binderfs.h
+    anbox/common/binder_device.cpp
+    anbox/common/binder_device.h
+    anbox/common/binder_device_allocator.cpp
+    anbox/common/binder_device_allocator.h
 
     anbox/container/client.cpp
     anbox/container/client.h
@@ -346,14 +352,3 @@
     anbox/system_configuration.h)
 
 add_library(anbox-core STATIC ${SOURCES})
-target_link_libraries(anbox-core
-  ${Boost_LDFLAGS}
-  ${Boost_LIBRARIES}
-  ${SDL2_LDFLAGS}
-  ${SDL2_LIBRARIES}
-  ${SDL2_IMAGE_LDFLAGS}
-  ${SDL2_IMAGE_LIBRARIES}
-  ${LXC_LDFLAGS}
-  ${LXC_LIBRARIES}
-  ${MIRCLIENT_LDFLAGS}
-  ${MIRCLIENT_LIBRARIES}

=== tests/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")

include_directories(
  ${Boost_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/external/android-emugl/host/include
  ${CMAKE_SOURCE_DIR}/src
)

macro(ANBOX_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src}
  )

  target_link_libraries(
    ${test_name}

    anbox-core

    ${GMOCK_LIBRARIES}
    ${GTEST_BOTH_LIBRARIES}

    ${ARGN}

    ${Boost_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
  )

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)
endmacro(ANBOX_ADD_TEST)

add_subdirectory(anbox)

=== debian/changelog ===
anbox (0.0~git20200526-1build1) groovy; urgency=medium

  * Rebuild against new libprotobuf23.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Jul 2020 09:41:42 +0200

anbox (0.0~git20200526-1) unstable; urgency=medium

  * New upstream snapshot.
  * Remove /var/lib/anbox when purge (Closes: #951035)
  * Refresh patches for new snapshot
  * Add libglm-dev to Build-Depends
  * Bump debhelper-compat to 13
  * Update Standards-Version to 4.5.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 28 May 2020 01:37:32 +0800

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: anbox
 Section: contrib/utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Shengjing Zhu <zhsj@debian.org>
+Maintainer: Shengjing Zhu <zhsj@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libboost-filesystem-dev,
  libboost-iostreams-dev,
  libboost-log-dev,
@@ -15,6 +14,7 @@
  libcap-dev,
  libegl1-mesa-dev,
  libgles2-mesa-dev,
+ libglm-dev,
  libgmock-dev,
  libproperties-cpp-dev,
  libprotobuf-dev,
@@ -24,7 +24,7 @@
  lxc-dev,
  protobuf-compiler,
  python3,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://anbox.io
 Vcs-Git: https://salsa.debian.org/zhsj/anbox.git
 Vcs-Browser: https://salsa.debian.org/zhsj/anbox
